(* ----------------------------------------------------- *)
(*                     FWDEMO.PAS                        *)
(*                                                       *)
(* Demonstriert den Gebrauch von FrameWindow anhand eines*)
(* statischen und zwei dynamischen Objekten.             *)
(*                                                       *)
(*         (c) 1991 by R.Reichert & toolbox              *)
(* ----------------------------------------------------- *)
PROGRAM FrameWinDemo;

USES ScrObj, WinVSM, FrameWin;

VAR
  Win1,
  Win2 : FrameWindowPtr;
  Win3 : FrameWindow;
  Crt  : WExtVSMPtr;
  i, j : BYTE;

BEGIN
  Crt := New (WExtVSMPtr,
              Init (New (ScreenObjPtr, Init (0, 0))));
  Win1 := New (FrameWindowPtr, Init (Crt));
  Win2 := New (FrameWindowPtr, Copy (Win1^));
  IF (Crt<>NIL) AND
     (Win1<>NIL) AND
     (Win2<>NIL) AND
     (Win3.Init (Crt)) THEN BEGIN

     {^^^^^^^^^^^^^^^^ statische Instanze wird so geprft,
       ob Fail in Init aufgerufen wurde                   }

    Crt^.ClrScr;
    Crt^.Fill ('', 7);
    Crt^.FillPart (10, 7, 70, 20, 7, ' ');
    Win1^.Init (Crt);
    Win1^.SetXY (10, 7, 70, 20);
    Win1^.SetTitles (' Hello World - this is window 1 ',
                     ' Good bye ');
    Win1^.SetFrame (FSingle);
    Win1^.Show;
    Win2^.SetShadow (Off);
    Win2^.SetXY (1, 1, 80, 25);
    Win2^.SetTitles (' Hello World - this is window 2 ',
                     ' ''bye bye ');
    Win2^.Show;
    Win3.SetColors (15, 15, 7, 112);
    Win3.SetShadow (On);
    Win3.SetXY (20, 10, 60, 16);
    Win3.SetTitles (' Hello World - this is window 3 ',
                    ' ''bye bye love ');
    Win3.Show;
    Readln;
    Win3.Done;
    Dispose (Win2, Done);
    Dispose (Win1, Done);
    Dispose (Crt, Done);
  END ELSE BEGIN
    Writeln ('*** Fehler: Objekte konnten nicht ',
             'initialisiert werden !');
    Writeln ('            Bitte Programm berprfen.');
    Writeln;
    Writeln ('Programm angehalten.');
  END;
END.
(* ----------------------------------------------------- *)
(*               Ende von FWDEMO.PAS                     *)
(* ----------------------------------------------------- *)
